program CCelevator;                 (* changing the elevation range for cc-txt-files *)

       const TABCHAR = #9;
             LFCHAR = #10; (* CC2 files have lines LF delimited *)
             CRCHAR = #13; (* CC3-CC5 files have lines CR-LF delimited *)

             CCedit = 0; (* LF terminated lines *)
             CC2    = 2; (* CR terminated lines *)
             CC3    = 3; (* CR+LF terminated lines *)

       type string255 = string(.255.);


(* sub-programs *)

       function wortTAB(zeile : string255; position : integer) : string255;
       (* letzte Aenderung: 16.08.1986 *)
       var i,j : integer;
           erg : string255;

       begin
          i:=1;
          for j:=1 to position do
          begin
            while ((zeile[i]=LFCHAR) or (zeile[i]=TABCHAR)) and (i <= Length(zeile)) do i:=Succ(i);
            if (i > Length(zeile)) then wortTAB:=''
            else
            begin
              erg:=zeile[i];
              i:=Succ(i);
              while ((zeile[i]<>LFCHAR) and (zeile[i]<>TABCHAR)) and (i <= Length(zeile)) do
              begin
                erg:=erg+zeile[i];
                i:=Succ(i);
              end;
              wortTAB:=erg
            end
          end
       end;   (*   wort(..) : string255    *)


       (* Konvert ASCII to Integer and Integer to ASCII *)
       (* letzte Aenderung: 27.07.1986 --- Manfred Fischer *)

       function Atoi(kette : string255) : integer;
       CONST ascii_of_0 = 48;
       VAR i,sign,lager : Integer;

       begin
         lager:=0;
         sign := +1;
         for i:=1 to length(kette) do
           case kette[i] of
             '0'..'9' : lager := (lager*10) + (ord(kette[i])-ascii_of_0);
             '-' : sign := -1;
             else ; (* lager:=(lager*10) + 0 *)
           end;
         Atoi := sign * lager
       end;         (** atoi() **)


       function Itoa(zahl : integer) : string255;
       CONST ascii_of_0 = 48;
       VAR zwisch,rest : integer;
           erg : string255;

       begin
         erg:='';
         zwisch:=abs(zahl);
         repeat
           rest:=(zwisch mod 10);
           zwisch:=(zwisch div 10);
           erg := (chr(ascii_of_0 + rest)) + erg
         until (zwisch < 1);
         if (zahl < 0) then Itoa := '-' + erg
         else Itoa := erg;
       end;


       function RestOfLine(s : string255; delimiter : char) : string255;
       var result : string255;
           i : integer;
       begin
         result := '';
         i := 1;
         while (i <= length(s)) and (s[i] <> delimiter) do i := Succ(i);
         while (i <= length(s)) do
         begin
           result := result + s[i];
           i := Succ(i);
         end;
         RestOfLine := result;    (* includes delimiter! *)
       end;

       procedure ReadLine(var InHandle : text; Format : integer; var s : string255);
       const linelengthlimit = 255;
       var i : integer; c : char; lineend : boolean;
       begin
         (* read the line from file until delimiter is reached, read delimiter *)
         (* and transfer the chars (except the delimiter(s)) to var s *)
         (* i/o-check done ! *)
         i := 0;
         s := '';
         lineend := FALSE;
         repeat;
           lineend := eof(InHandle);
           if not lineend then
           begin
             read(InHandle, c);
             if (c = LFCHAR) then
             begin
               if (Format = 3) or (Format = 0) then lineend := TRUE
             end
             else if (c = CRCHAR) then
             begin
               if (Format = 2) then lineend := TRUE
             end
             else (* valid data *) if (i < linelengthlimit) then
             begin
               i := Succ(i);
               s := s + c;
             end;
           end;
         until lineend;
       end;

       procedure WriteLine(var OutHandle : text; Format : integer; var s : string255);
       begin
         if (Format = 2) then write(OutHandle, s, CRCHAR)
         else write(OutHandle, s, CRCHAR, LFCHAR);
       end;



var s, s0, header, inputfilename, outputfilename : string255;
    InfileFormat : integer;               (* determines CloseCombat format *)
    OutfileFormat : integer;

    infile, outfile : Text;      (* file handles *)

    r : real;
    i, minElev, maxElev, newMax, newMin : integer;
    linecounter : integer;
    value : integer;

begin
   OutfileFormat := 2; (* CC2 as default *)
   InfileFormat := 2;  (* CC2 as default *)
   minElev := -1; (* not valid *)
   maxElev := -1; (* not valid *)

   writeln('CCelevat - a CloseCombat map.txt-file elevation range changer by Mafi');
   writeln('written in TurboPascal - sent comments to closecombat2@claranet.de');
   writeln('be carefull - no I/O-checking is done');
   writeln('the input file must reside in the same folder as the program');
   writeln('input format will be:  auto detected');
   write('output format will be: same as input');

   writeln;
   (* now looking for the input file *)
   (* and setting up the new output file *)

   write('enter file name: ');
   readln(inputfilename);



   Assign(infile, inputfilename);
   Reset(infile); (* open file for input *)

   (* first: checking the header informations of input file *)

   readln(infile, header);

   if (header(.1.) = '1') and (header(.2.) = '0') then
   begin
       write('valid CC3-header found');
       InfileFormat := 3;
   end
   else if (header(.1.) = '4') and (header(.2.) = '1') then
   begin
     if (length(header) > 2) then
     begin
       if (header(.3.) = LFCHAR) then
       begin
         write('old CCedit format - CC2');
         InfileFormat := 0;
       end
       else
       begin
         write('valid CC2-header found');
         InfileFormat := 2;
       end
     end
     else
     begin
       write('valid CC2-header found');
       InfileFormat := 2;
     end
   end
   else
   begin
       writeln('aborting: no CC-header: ', header);
       Close(infile);
       Exit;
   end;

   Close(Infile);
   Reset(Infile); (* read again *)

   (* reading all the datas to check the former values *)

   write(' - processing line ',' ':5);
   linecounter := 1;

   while not eof(Infile) do
   begin
     ReadLine(Infile, InfileFormat, s);
     write(#8#8#8#8#8,linecounter:5);
     linecounter := Succ(linecounter);
     if (InfileFormat = 2) then
     begin
       s0 := WortTab(s, 18);
       if (Length(s0) > 0) then if (s0(.1.) in (.'0'..'9'.)) then
       begin
         value := AtoI(s0);
         if (minElev < 0) then minElev := value
         else if (minElev > value) then minElev := value;
         if (maxElev < 0) then maxElev := value
         else if (maxElev < value) then maxElev := value;
       end;
     end
     else for i := 0 to 15 do
     begin
       s0 := WortTab(s, 18 + i);
       if (Length(s0) > 0) then if (s0(.1.) in (.'0'..'9'.)) then
       begin
         value := AtoI(s0);
         if (minElev < 0) then minElev := value
         else if (minElev > value) then minElev := value;
         if (maxElev < 0) then maxElev := value
         else if (maxElev < value) then maxElev := value;
       end;
     end
   end;
   Close(Infile);

   (* ask for new elevation range *)

   writeln;
   writeln('existing elevation range is: ',minElev,' - ',maxElev);
   repeat
     write('enter new elevation minimum: ');
     readln(newMin);
     write('enter new elevation maximum: ');
     readln(newMax);
   until (newMin <= newMax);

   if (InfileFormat = 0) then OutfileFormat := 2
   else OutFileFormat := InfileFormat;
   if (OutfileFormat = 2) then outputfilename := 'MAPE-CC2'
   else outputfilename := 'NEWE-CC3.txt';

   Reset(Infile);
   Assign(outfile, outputfilename);
   Rewrite(outfile); (* create new file for output *)
   write(' - processing line ',' ':5);
   linecounter := 1;

   (* now start reading the lines, changing the values and writing them *)

   while not eof(Infile) do
   begin
     ReadLine(Infile, InfileFormat, s);
     write(#8#8#8#8#8,linecounter:5);
     linecounter := Succ(linecounter);
     for i := 1 to 17 do
     begin
       s0 := WortTab(s, i);
       write(Outfile, s0, TABCHAR);
     end;
     if (InfileFormat = 2) then
     begin
       s0 := WortTab(s, 18);
       if (Length(s0) > 0) then if (s0(.1.) in (.'0'..'9'.)) then
       begin
         r := 1.0 * (AtoI(s0) - minElev) / (maxElev - minElev);  (* result 0.0 - 1.0 *)
         value := Round(r * (newMax - newMin)) + newMin;
         write(OutFile, value);
       end;
       s0 := '';
       WriteLine(OutFile, OutfileFormat, s0);
     end
     else
     begin
       for i := 0 to 14 do
       begin
         s0 := WortTab(s, 18 + i);
         if (Length(s0) > 0) then if (s0(.1.) in (.'0'..'9'.)) then
         begin
           r := 1.0 * (AtoI(s0) - minElev) / (maxElev - minElev);  (* result 0.0 - 1.0 *)
           value := Round(r * (newMax - newMin)) + newMin;
           write(OutFile, value);
         end;
         write(Outfile, TABCHAR);
       end;
       s0 := WortTab(s, 33);
       if (Length(s0) > 0) then if (s0(.1.) in (.'0'..'9'.)) then
       begin
         r := 1.0 * (AtoI(s0) - minElev) / (maxElev - minElev);  (* result 0.0 - 1.0 *)
         value := Round(r * (newMax - newMin)) + newMin;
         write(OutFile, value);
       end;
       s0 := '';
       WriteLine(OutFile, OutfileFormat, s0);
     end
   end;
   Close(Infile);
   Close(Outfile);

   (* done *)
   writeln('job done, result in ', outputfilename);
end.


